package fitNesseFixture;

import project.User;

import java.util.ArrayList;

import exceptions.CategoryInvalidException;
import exceptions.DateInvalidException;
import exceptions.LoginInvalidException;
import exceptions.MailInvalidException;
import exceptions.PasswordInvalidException;
import exceptions.PriceInvalidException;
import exceptions.TitleInvalidException;
import exceptions.UsernameEmailEmptyException;
import project.Auction;
import project.Category;
import project.Item;

public class UserFixture {

	private String username, password, email, title, category;
	private double price;
	Category c;

	public UserFixture(String cat) {

		c = new Category(cat);

	}

	public UserFixture(String title, String category) {

		c = new Category(category);

		Item i = Item.getInstance();

		i.setTitle(title);
		i.setCategory(c);

	}

	public UserFixture(String usernameInput, String mailInput, String passwordInput) {

		User u = User.getInstance();

		u.setUsername(usernameInput);
		u.setEmail(mailInput);
		u.setPassword(passwordInput);

	}

	public String userLogin() {

		try {

			if (User.login(username, email, password)) {

				return "Login worked!";

			}

		} catch (UsernameEmailEmptyException e) {

			return e.getMessage();

		} catch (PasswordInvalidException e) {

			return e.getMessage();

		} catch (MailInvalidException e) {

			return e.getMessage();

		} catch (LoginInvalidException e) {

			return e.getMessage();

		}

		return null;

	}

	public String searchItem() {

		User u = User.getInstance();
		ArrayList<Item> a;

		try {

			a = u.searchItem(title, category);

			if (a.size() >= 0) {

				return "Search performed!";

			}

		} catch (CategoryInvalidException e) {

			return e.getMessage();

		} catch (TitleInvalidException e) {

			return e.getMessage();

		}

		return null;

	}

	public String searchAuction() {

		User u = User.getInstance();
		ArrayList<Auction> a;

		try {

			a = u.searchAuction(price, title, category);

		} catch (CategoryInvalidException e) {

			return e.getMessage();

		} catch (TitleInvalidException e) {

			return e.getMessage();

		} catch (PriceInvalidException e) {

			return e.getMessage();

		}

		if (a.size() >= 0) {

			return "Search performed!";

		}

		return null;

	}

	public void setPrice(double price) {

		this.price = price;

	}

	public void setUsername(String username) {

		this.username = username;

	}

	public void setPassword(String password) {

		this.password = password;

	}

	public void setEmail(String email) {

		this.email = email;

	}

	public void setTitle(String title) {

		this.title = title;

	}

	public void setCategory(String category) {

		this.category = category;

	}

}
